macroScript RC_Paneller
	category:"RailCloneScripts"

(
try(DestroyDialog rc_toSurface)catch()

Rollout rc_toSurface "RailClone to Surface"
(
	Pickbutton btn_pick_rc "Pick RC object" 
	button btn_convert "Apply RC to Faces" enabled:false
	local railcloneObject	
	
	on btn_pick_rc picked obj do
	(
		btn_pick_rc.text = obj.name
		railcloneObject = obj
		btn_convert.enabled=true
	)
	on btn_convert pressed do 
	(
		sourceObject =  $
		selectedFaces = polyOp.getFaceSelection $ as array
		
		if keyboard.ShiftPressed == true then
		(
			the_pos = polyop.getfacecenter sourceObject selectedFaces[1]
			the_dir = polyop.getfacenormal sourceObject selectedFaces[1]	
		
			macros.run "PolyTools" "Outline"		
			local splineName = "roof" + i as string
			$.EditablePoly.createShape splineName off $
--print selectedFaces[i]
			newSpline = getnodebyname splineName
			select newSpline
				
--Clone RailClone Object
			maxOps.cloneNodes railcloneObject cloneType:#copy newNodes:&newRC 
			select newRC

--Rotate RailClone object
			$.dir = the_dir
			$.pos = the_pos
			$.banode[1] = newSpline
			newSpline.name = "RoofSpline"

--Align RailClone Object to Face
		
			select SourceObject 
			subobjectLevel = 4	
) else 
(


		with redraw off
		for i=1 to selectedFaces.count do 
		(
--init 
		the_pos = polyop.getfacecenter sourceObject selectedFaces[i]
		the_dir = polyop.getfacenormal sourceObject selectedFaces[i]
--createspline
		select SourceObject
		$.EditablePoly.SetSelection #face #{selectedFaces[i]}			
		local splineName = "roof" + i as string
		$.EditablePoly.ConvertSelection #Face #Edge 
		subobjectLevel = 2
		$.EditablePoly.createShape splineName off $ 
		--print selectedFaces[i]
		newSpline = getnodebyname splineName
		select newSpline
				
	
--Clone RailClone Object
		maxOps.cloneNodes railcloneObject cloneType:#copy newNodes:&newRC 
		select newRC

-- Rotate RailClone object
		$.dir = the_dir
		$.pos = the_pos
		$.banode[1] = newSpline
		newSpline.name = "RoofSpline"

--Align RailClone Object to Face
		
		select SourceObject 
		subobjectLevel = 4
	)		)
)

)
CreateDialog rc_toSurface
)